﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Collections.ObjectModel;
using System.Management.Automation;
using System.Management.Automation.Runspaces;
using System.Net;
using System.Threading;
using System.IO;
using System.Configuration;

namespace FirewallService
{
    public partial class Service1 : ServiceBase
    {
        private ConfigurationSettings config;
        private System.Timers.Timer timer1;
        private Mutex mutex;
        public string LastIPAddress = "";
        public Service1()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            System.Configuration.AppSettingsReader appReader = new System.Configuration.AppSettingsReader();
            timer1 = new System.Timers.Timer(Convert.ToDouble(appReader.GetValue("Interval", typeof(string))));

            FileSystemWatcher watcher = new FileSystemWatcher();
            watcher.Path = System.AppDomain.CurrentDomain.BaseDirectory;
            /* Watch for changes in LastAccess and LastWrite times, and
               the renaming of files or directories. */
            watcher.NotifyFilter = NotifyFilters.LastAccess | NotifyFilters.LastWrite
               | NotifyFilters.FileName | NotifyFilters.DirectoryName;
            // Only watch text files.
            watcher.Filter = "*.config";

            // Add event handlers.
            watcher.Changed += new FileSystemEventHandler(OnChanged);

            // Begin watching.
            watcher.EnableRaisingEvents = true;
            mutex = new Mutex(false);
            timer1.Elapsed += new System.Timers.ElapsedEventHandler(timer1_Elapsed);
            timer1.Start();
            

            string ipToAdd = appReader.GetValue("Host", typeof(string)).ToString();
            EventLog.WriteEntry("Firewall Updater monitoring host '" + ipToAdd + "'");
        }

        void timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            mutex.WaitOne();
            try
            {
                //EventLog.WriteEntry("Tick");
                System.Configuration.AppSettingsReader appReader = new System.Configuration.AppSettingsReader();
                string ipToAdd = appReader.GetValue("Host", typeof(string)).ToString();
                IPAddress[] addresslist = Dns.GetHostAddresses(ipToAdd);


                if (addresslist.Length > 0)
                {
                    if (LastIPAddress != addresslist[0].ToString())
                    {
                        RunScript("netsh advfirewall firewall delete rule name=\"" + appReader.GetValue("RuleName", typeof(string)).ToString() + "\" protocol=TCP");
                        string scripttext = "netsh advfirewall firewall add rule name=\"" + appReader.GetValue("RuleName", typeof(string)).ToString() + "\" dir=in action=allow protocol=TCP remoteip=" + addresslist[0];
                        RunScript(scripttext);
                        EventLog.WriteEntry("Changed firewall rule for RDP. New IP Address: " + addresslist[0]);
                        LastIPAddress = addresslist[0].ToString();
                    }
                }
            }
            finally
            {
                mutex.ReleaseMutex();
            }
        }

        protected override void OnStop()
        {
            EventLog.WriteEntry("Firewall Updater exiting.");
        }


        private string RunScript(string scriptText)
        {
            // create Powershell runspace

            Runspace runspace = RunspaceFactory.CreateRunspace();

            // open it

            runspace.Open();

            // create a pipeline and feed it the script text

            Pipeline pipeline = runspace.CreatePipeline();
            pipeline.Commands.AddScript(scriptText);

            // add an extra command to transform the script
            // output objects into nicely formatted strings

            // remove this line to get the actual objects
            // that the script returns. For example, the script

            // "Get-Process" returns a collection
            // of System.Diagnostics.Process instances.

            pipeline.Commands.Add("Out-String");

            // execute the script
            Collection<PSObject> results = pipeline.Invoke();

            // close the runspace

            runspace.Close();

            // convert the script result into a single string

            StringBuilder stringBuilder = new StringBuilder();
            foreach (PSObject obj in results)
            {
                stringBuilder.AppendLine(obj.ToString());
            }

            return stringBuilder.ToString();
        }

        private static void OnChanged(object source, FileSystemEventArgs e)
        {

            ConfigurationManager.RefreshSection("appSettings");
        }
    }
}
